#ifndef PROPSLIDER_H
#define PROPSLIDER_H

#include <QSlider>


/*
  Widget qui traduit les valeurs entières renvoyées par un QSlider en
  double pour contrôler une propriété en fonction d’un minimum, d’un
  maximum et d’un pas.
 */
class PropSlider : public QSlider {
	Q_OBJECT

	double min = 0;
	double max = 1;
	double step = .1;
	double value = .5;
	int mapped_value;

	int mapValue() const;
	double unmapValue() const;

  public:
	PropSlider(QWidget *parent=nullptr);
	void setMinimum(double min);
	void setMaximum(double max);
	void setStep(double step);

  signals:
	void valueChanged(double value);

  public slots:
	void setValue(double value);

  private slots:
	// Connecté au QSlider
	void setValue(int mapped_value);
};


#endif
